﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    WinJS.strictProcessing();

    //変数
    var canvas;
    var context;
    var images=new Array();
    var updateTime=0;
    var posX= 60;
    var posY=120;
    var vx=10;
    var vy=10;

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //コンテキストの取得
        canvas=$("canvas");
        context=canvas.getContext("2d");
    
        //イメージの読み込み
        var image=new Image();
        image.src="images/sample.png";
        images.push(image);
        preload(images,animate);
    }

    //アプリ開始
    Application.start();

    //イメージ読み込み待ち
    function preload(images,onComplete) {
        var loadImages=function() {
            var count=0;
            for(var i=0;i<images.length;i++) {
                if(images[i].complete) count++;
            }
            if (count<images.length) {
                setTimeout(loadImages,100);
            } else {
                onComplete();
            }
        };
        loadImages();
    }
    
    //アニメーションフレームのループ処理
    function animate() {
        var currentTime=new Date().getTime();//(2)
        if (updateTime<=currentTime) {
            updateTime=currentTime+50-currentTime%50;
            onDraw();
        }
        window.msRequestAnimationFrame(animate);//(1)
    }

    //描画時に呼ばれる
    function onDraw() {
        //イメージの描画
        context.clearRect(0,0,canvas.width,canvas.height);
        context.drawImage(images[0],posX-120,posY-120);

        //イメージの移動(3)
        if (posX<0 || canvas.width <posX) vx=-vx;
        if (posY<0 || canvas.height<posY) vy=-vy;
        posX+=vx;
        posY+=vy;
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();