﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    WinJS.strictProcessing();

    //変数
    var canvas;
    var context;

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //コンテキストの取得
        canvas=$("canvas");
        context=canvas.getContext("2d");

        //ラインの描画(1)
        setColor(255,0,0);
        drawLine(50,10,50,90);

        //ポリラインの描画(1)
        var ax=new Array(110+0,110+60,110+20,110+80,110+ 0);
        var ay=new Array( 10+0, 10+10, 10+40, 10+50, 10+80);
        setColor(255,0,0);
        drawPolyline(ax,ay);
    
        //四角形の描画(2)
        setColor(0,255,0);
        drawRect(10,100,80,80);

        //四角形の塗り潰し(2)
        setColor(0,255,0);
        fillRect(110,100,80,80);

        //円の描画(3)
        setColor(0,0,255);
        drawCircle(10+40,200+40,40);

        //円の塗り潰し(3)
        setColor(0,0,255);
        fillCircle(110+40,200+40,40);
    }

    //アプリ開始
    Application.start();

    //色の指定
    function setColor(r,g,b) {
        var color="rgb("+r+","+g+","+b+")";
        context.strokeStyle=color;
        context.fillStyle  =color;
    }

    //ラインの描画(1)
    function drawLine(x0,y0,x1,y1) {
        context.beginPath();
        context.moveTo(x0,y0);
        context.lineTo(x1,y1);   
        context.stroke();
    }

    //ポリラインの描画(1)
    function drawPolyline(ax,ay) {
        context.beginPath();
        context.moveTo(ax[0],ay[0]);
        for (var i=1;i<ax.length;i++){
            context.lineTo(ax[i],ay[i]);   
        }
        context.stroke();
    }

    //四角形の描画(2)
    function drawRect(x,y,w,h) {
        context.strokeRect(x,y,w,h);
    }

    //四角形の塗り潰し(2)
    function fillRect(x,y,w,h) {
        context.fillRect(x,y,w,h);
    }

    //円の描画(3)
    function drawCircle(x,y,r) {
        context.beginPath();
        context.arc(x,y,r,0,Math.PI*2,true);
        context.stroke();
    }

    //円の塗り潰し(3)
    function fillCircle(x,y,r) {
        context.beginPath();
        context.arc(x,y,r,0,Math.PI*2,true);
        context.fill();
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();