﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    WinJS.strictProcessing();

    //変数
    var canvas;
    var context;
    var images=new Array();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //コンテキストの取得
        canvas=$("canvas");
        context=canvas.getContext("2d");

        //イメージの読み込み(1)
        for (var i=0;i<2;i++) {
            var image=new Image();
            image.src="/images/sample"+i+".png";
            images.push(image);
        }

        //イメージ読み込み待ち
        preload(images,onDraw);
    }

    //アプリ開始
    Application.start();

    //イメージ読み込み待ち(2)
    function preload(images,onComplete) {
        var loadImages=function() {
            var count=0;
            for(var i=0;i<images.length;i++) {
                if(images[i].complete) count++;
            }
            if (count<images.length) {
                setTimeout(loadImages,100);
            } else {
                onComplete();
            }
        };
        loadImages();
    }

    //描画時に呼ばれる
    function onDraw() {
        //イメージの描画(3)
        context.drawImage(images[0],0,0);
        context.drawImage(images[1],480,0,480,480);
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();