﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    WinJS.strictProcessing();

    //変数
    var canvas;
    var context;
    var keyCode=-1;
    var keyChar="";

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //コンテキストの取得
        canvas=$("canvas");
        context=canvas.getContext("2d");

        //イベントリスナーの追加(1)
        document.body.onkeydown=onKeyDown;
        document.body.onkeyup=onKeyUp;

        //描画
        onDraw();
    }

    //アプリ開始
    Application.start();

    //キーダウンイベントの処理(1)
    function onKeyDown(event) {
        keyCode=event.keyCode;
        keyChar=event.key;
        onDraw();
    }

    //キーアップイベントの処理(1)
    function onKeyUp(event) {
        keyCode=-1;
        keyChar="";
        onDraw();
    }

    //描画時に呼ばれる
    function onDraw() {
        //画面のクリア
        context.clearRect(0,0,canvas.width,canvas.height);

        //フォントと文字色の指定
        context.font="48px 'Meiryo UI'";
        context.strokeStyle="rgb(0,0,0)";
        context.fillStyle  ="rgb(0,0,0)";

        //文字列の表示
        context.fillText("KeyEx>",0,48);
        context.fillText("keyCode:"+keyCode,0,48*2);
        context.fillText("key:"+keyChar,0,48*3);
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();