﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    WinJS.strictProcessing();

    //変数
    var canvas;
    var context;

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //コンテキストの取得(3)
        canvas=$("canvas");
        context=canvas.getContext("2d");

        //フォントの指定(4)
        context.font="48px 'Meiryo UI'";

        //文字色の指定(5)
        context.strokeStyle="rgb(0,0,0)";
        context.fillStyle  ="rgb(0,0,0)";

        //文字列の描画(6)
        context.fillText("キャンバスサイズ:"+
            canvas.width+"x"+canvas.height+"px",0,48);
        context.fillText("文字幅:"+
            context.measureText("A").width+"px",0,48*2);//(7)
        
        //24pxの文字列の表示
        context.font="24px 'Meiryo UI'";
        context.strokeStyle="rgb(255,0,0)";
        context.fillStyle  ="rgb(255,0,0)";
        context.fillText("24px",0,48*4);

        //36pxの文字列の表示
        context.font="36px 'Meiryo UI'";
        context.strokeStyle="rgb(0,255,0)";
        context.fillStyle  ="rgb(0,255,0)";
        context.fillText("36px",0,48*5);

        //48pxの文字列の表示
        context.font="48px 'Meiryo UI'";
        context.strokeStyle="rgb(0,0,255)";
        context.fillStyle  ="rgb(0,0,255)";
        context.fillText("48px",0,48*6);
    }

    //アプリ開始
    Application.start();

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();