﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var MessageDialog=Windows.UI.Popups.MessageDialog;
    var UICommand=Windows.UI.Popups.UICommand;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //イベントリスナーの指定(3)
        $("addButton").addEventListener("click",function(){showDialog("追加");});
        $("deleteButton").addEventListener("click",function(){showDialog("削除");});
        $("cameraButton").addEventListener("click",function(){showDialog("カメラ");});
    }

    //アプリ開始
    Application.start();

    //ダイアログの表示
    function showDialog(text) {
        var md=new MessageDialog(text);
        var cmd=new UICommand();
        cmd.label='OK';
        md.commands.append(cmd);
        md.showAsync();
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();