﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var MessageDialog=Windows.UI.Popups.MessageDialog;
    var UICommand=Windows.UI.Popups.UICommand;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //イベントリスナーの指定(2)
        $("button0").addEventListener("click",button0_onClick);
        $("button1").addEventListener("click",button1_onClick);
    };

    //アプリ開始
    Application.start();

    //ダイアログボタン押下時に呼ばれる
    function button0_onClick() {
        showDialog("ボタンを押した");
    }

    //Yes/Noダイアログボタン押下時に呼ばれる
    function button1_onClick() {
        showYesNoDialog("Yes/Noを選択",function(c){
            showDialog("結果:"+c.label);
        });
    }

    //ダイアログの表示(3)
    function showDialog(text) {
        var md=new MessageDialog(text);
        var cmd=new UICommand();
        cmd.label="OK";
        md.commands.append(cmd);
        md.showAsync();
    }

    //Yes/Noダイアログの表示(4)
    function showYesNoDialog(text,onResult) {
        var md=new MessageDialog(text);
        var resultOptions=["Yes","No"];
        for(var i=0;i<resultOptions.length;i++) {
            var cmd=new UICommand();
            cmd.label=resultOptions[i];
            md.commands.append(cmd);
        }     
        md.showAsync().done(onResult);//(5)
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();