﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var MessageDialog=Windows.UI.Popups.MessageDialog;
    var UICommand=Windows.UI.Popups.UICommand;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //イベントリスナーの指定
        $("resultButton").addEventListener("click",resultButton_onClick);
    };

    //アプリ開始
    Application.start();

    //結果ボタン押下時に呼ばれる(4)
    function resultButton_onClick() {
        var checkbox=$("checkbox");
        var radios=document.getElementsByName("radio");
        var radioSelectedIndex=-1;
        for (var i=0;i<radios.length;i++) {
            if (radios[i].checked) radioSelectedIndex=i;
        }  
        var select=$("select");
        showDialog(
            "チェックボックス>"+checkbox.checked+"\n"+
            "ラジオボタン>"+radioSelectedIndex+"\n"+
            "セレクト>"+select.selectedIndex);
    }

    //ダイアログの表示
    function showDialog(text) {
        var md=new MessageDialog(text);
        var cmd=new UICommand();
        cmd.label='OK';
        md.commands.append(cmd);
        md.showAsync();
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();