﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var Binding=WinJS.Binding;
    var Namespace=WinJS.Namespace;
    WinJS.strictProcessing();

    //ログイン情報1のデータオブジェクト(1)
    var login1={
        name: "ラビ山", 
        photoURL: "http://npaka.net/metro/sample0.png",
        userType: "admin"
    };

    //ログイン情報1のコンバータ(2)
    function userTypeToColor(type) { 
        return type=="admin"?"red":"black"; 
    }

    //ログイン情報2(4)
    Namespace.define("login2",{ 
        //データオブジェクト
        data: { 
            name: "名無し", 
            photoURL: "http://npaka.net/metro/sample1.png",
            userType: "guest"
        }, 
        //コンバータ
        userTypeToColor: Binding.converter(function(type) { 
            return type=="admin"?"red":"black"; 
        }) 
    });

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //データを1つずつUIに適用(3)
        $("name1").innerText=login1.name; 
        $("name1").style.color=userTypeToColor(login1.userType); 
        $("photo1").src=login1.photoURL; 

        //データをまとめてUIに適用(5)
        Binding.processAll($("loginInfo2"),login2.data);

        //データ変更時にUIに適用(7)
        var observable=Binding.as(login2.data);
        observable.bind("name",function (newValue,oldValue) {
            $("name2").textContent=newValue;
        });

        //データ変更(8)
        observable.name="マヨネーズ";
    };

    //アプリ開始
    Application.start();

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();

