﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var MessageDialog=Windows.UI.Popups.MessageDialog;
    var UICommand=Windows.UI.Popups.UICommand;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //イベントリスナーの指定
        $("button0").addEventListener("click",button0_onClick);
        $("button1").addEventListener("click",button1_onClick);
        $("button2").addEventListener("click",button2_onClick);
        $("messageFlyout_okButton").addEventListener("click",messageFlyout_okButton_onClick);
        $("yesnoFlyout_yesButton").addEventListener("click",yesnoFlyout_yesButton_onClick);
        $("yesnoFlyout_noButton").addEventListener("click",yesnoFlyout_noButton_onClick);
        $("textFlyout_okButton").addEventListener("click",textFlyout_okButton_onClick);
        $("textFlyout_cancelButton").addEventListener("click",textFlyout_cancelButton_onClick);
    };

    //アプリ開始
    Application.start();

    //メッセージフライアウトボタン押下時に呼ばれる
    function button0_onClick() {
        var button=$("button0");
        $("messageFlyout").winControl.show(button);//(2)
    }

    //Yes/Noフライアウトボタン押下時に呼ばれる
    function button1_onClick() {
        var button=$("button1");
        $("yesnoFlyout").winControl.show(button);//(2)
    }

    //テキストフライアウト押下時に呼ばれる
    function button2_onClick() {
        var button=$("button2");
        $("textFlyout").winControl.show(button);//(2)
    }

    //メッセージフライアウトのOKボタン0クリック時に呼ばれる
    function messageFlyout_okButton_onClick() {
        $("messageFlyout").winControl.hide();
    }

    //Yes/NoフライアウトのYesボタンクリック時に呼ばれる
    function yesnoFlyout_yesButton_onClick() {
        $("yesnoFlyout").winControl.hide();
        showDialog("Yesボタンを押した");
    }

    //Yes/NoフライアウトのNoボタンクリック時に呼ばれる
    function yesnoFlyout_noButton_onClick() {
        $("yesnoFlyout").winControl.hide();
        showDialog("Noボタンを押した");
    }

    //テキストフライアウトのOKボタンクリック時に呼ばれる
    function textFlyout_okButton_onClick() {
        $("textFlyout").winControl.hide();
        showDialog($("textFlyout_textarea").value);
    }

    //テキストフライアウトのCancelボタンクリック時に呼ばれる
    function textFlyout_cancelButton_onClick() {
        $("textFlyout").winControl.hide();
    }

    //ダイアログの表示
    function showDialog(text) {
        var md=new MessageDialog(text);
        var cmd=new UICommand();
        cmd.label="OK";
        md.commands.append(cmd);
        md.showAsync();
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();