﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var MessageDialog=Windows.UI.Popups.MessageDialog;
    var Binding=WinJS.Binding;
    var Namespace=WinJS.Namespace;
    var UICommand=Windows.UI.Popups.UICommand;
    WinJS.strictProcessing();

    //データリストの生成(3)
    var data=new Array();
    for (var i=0;i<30;i++) {
        data.push({title: "ボタン"+i});
    }

    //データバインディング用のデータリストの生成(4)
    var dataList=new Binding.List(data);
    Namespace.define("ListViewEx",{
        dataList: dataList 
    }); 

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //イベントリスナーの指定(5)
        $("listView").addEventListener("iteminvoked",listView_onItemInvoked);
    }

    //アプリ開始
    Application.start();

    //リストビュー要素クリック時に呼ばれる(5)
    function listView_onItemInvoked(event) {
        showDialog("ボタン"+event.detail.itemIndex+"を押した");
    }

    //ダイアログの表示
    function showDialog(text) {
        var md=new MessageDialog(text);
        var cmd=new UICommand();
        cmd.label='OK';
        md.commands.append(cmd);
        md.showAsync();
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();