﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var MessageDialog=Windows.UI.Popups.MessageDialog;
    var UICommand=Windows.UI.Popups.UICommand;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
    };

    //WinJSコントロールの準備完了時に呼ばれる
    Application.onready=function() {
        //イベントリスナーの指定
        $$(".win-backbutton").addEventListener("click",function(){showDialog("バック");});
        $$(".titlearea").addEventListener("click",showHeaderMenu);
        $("menuItem0").addEventListener("click",function(){showDialog("メニュー項目0");});
        $("menuItem1").addEventListener("click",function(){showDialog("メニュー項目1");});
        $("menuItem2").addEventListener("click",function(){showDialog("メニュー項目2");});
        $("homeMenuItem").addEventListener("click",function(){showDialog("ホーム");});
    };

    //アプリ開始
    Application.start();

    //ヘッダーメニューの表示(5)
    function showHeaderMenu() {
        var menu=$("headerMenu").winControl;
        menu.anchor=$$("header .pagetitle");
        menu.placement="bottom";
        menu.alignment="left";
        menu.show();
    }

    //ダイアログの表示
    function showDialog(text) {
        var md=new MessageDialog(text);
        var cmd=new UICommand();
        cmd.label="OK";
        md.commands.append(cmd);
        md.showAsync();
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }

    //要素の取得
    function $$(expression) {
        return document.querySelector(expression);
    }
})();