﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var Navigation=WinJS.Navigation;
    var Pages=WinJS.UI.Pages;
    var Utilities=WinJS.Utilities;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll().then(function() {//(6)
                //セッションステートの復帰(5)
                var url=Application.sessionState.lastUrl || 
                    "/html/page0.html";
                return Navigation.navigate(url);//(1)
            }));
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
    };

    //アプリ開始
    Application.start();

    //ページ遷移時に呼ばれる(2)
    Navigation.addEventListener("navigated",function(ev) {
        //URLとホストの取得
        var url=ev.detail.location;
        var host=$("contentHost");
        
        //ページのクリア(4)
        if (host.winControl && host.winControl.unload) {
            host.winControl.unload();
        }
        Utilities.empty(host);

        //ページのレンダリング(3)
        ev.detail.setPromise(Pages.render(
            url,host,ev.detail.state).then(function() {
            //セッションステートの保存(5)
            Application.sessionState.lastUrl=url;
        }));
    });

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();