﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var Binding=WinJS.Binding;
    var Namespace=WinJS.Namespace;
    WinJS.strictProcessing();

    //データリストの生成
    var data=new Array();
    for (var i=0;i<10;i++) {
        data.push({title: "Star" +i,text: "ウサ山です",picture: "images/sample0.png"}); 
        data.push({title: "Mayonnaise" +i,text: "マヨどうぞ",picture: "images/sample1.png"}); 
        data.push({title: "Carrot" +i,text: "ニンジンうまい",picture: "images/sample2.png"}); 
    }
    var dataList=new Binding.List(data);

    //グループ情報付きのデータリストの生成(7)
    var groupedList=dataList.createGrouped(getGroupKey,getGroupData,compareGroups);
    Namespace.define("SemanticZoomEx",{
        groupedList: groupedList 
    }); 

    //グループキーを生成する関数(8)
    function getGroupKey(dataItem) {
        return dataItem.title.toUpperCase().charAt(0);
    }

    //グループデータを取得する関数(9)
    function getGroupData(dataItem) {
        return {title: dataItem.title.toUpperCase().charAt(0)};
    }

    //グループをソートする関数(10)
    function compareGroups(left,right) {
        return left.charCodeAt(0)-right.charCodeAt(0);
    }

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
    }

    //アプリ開始
    Application.start();
})();