﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var ToastTemplateType=Windows.UI.Notifications.ToastTemplateType;
    var ToastNotification=Windows.UI.Notifications.ToastNotification;
    var ToastNotificationManager=Windows.UI.Notifications.ToastNotificationManager;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //イベントリスナーの指定
        $("button0").addEventListener("click",button0_onClick);
        $("button1").addEventListener("click",button1_onClick);
        $("button2").addEventListener("click",button2_onClick);
        $("button3").addEventListener("click",button3_onClick);
    };

    //アプリ開始
    Application.start();

    //トーストの表示(イメージ+テキスト)押下時に呼ばれる
    function button0_onClick() {
        showToast0("/images/sample.png","トーストの表示\n2行目\n3行目");
    }

    //トーストの表示(イメージ+タイトル+テキスト)押下時に呼ばれる
    function button1_onClick() {
        showToast1("/images/sample.png","トーストの表示","2行目\n3行目");
    }

    //トーストの表示(テキスト)押下時に呼ばれる
    function button2_onClick() {
        showToast2("トーストの表示\n2行目\n3行目");
    }

    //トーストの表示(タイトル+テキスト)押下時に呼ばれる
    function button3_onClick() {
        showToast3("トーストの表示","2行目\n3行目");
    }

    //イメージ+テキストのトースト表示
    function showToast0(imageSrc,text) {
        var toastXml=ToastNotificationManager.getTemplateContent(   //(1)
            ToastTemplateType.toastImageAndText01);
        var imageNodes=toastXml.getElementsByTagName("image");      //(2)
        imageNodes[0].setAttribute("src",imageSrc);
        var textNodes=toastXml.getElementsByTagName("text");        //(3)
        textNodes[0].appendChild(toastXml.createTextNode(text));
        var notifier=ToastNotificationManager.createToastNotifier();//(4)
        notifier.show(new ToastNotification(toastXml));
    }

    //イメージ+タイトル+テキストのトースト表示
    function showToast1(imageSrc,title,text) {
        var toastXml=ToastNotificationManager.getTemplateContent(   //(1)
            ToastTemplateType.toastImageAndText02);
        var imageNodes=toastXml.getElementsByTagName("image");      //(2)
        imageNodes[0].setAttribute("src",imageSrc);
        var textNodes=toastXml.getElementsByTagName("text");        //(3)
        textNodes[0].appendChild(toastXml.createTextNode(title));
        textNodes[1].appendChild(toastXml.createTextNode(text));
        var notifier=ToastNotificationManager.createToastNotifier();//(4)
        notifier.show(new ToastNotification(toastXml));
    }

    //テキストのトースト表示
    function showToast2(text) {
        var toastXml=ToastNotificationManager.getTemplateContent(   //(1)
            ToastTemplateType.toastText01);                 
        var textNodes=toastXml.getElementsByTagName("text");        //(3)
        textNodes[0].appendChild(toastXml.createTextNode(text));
        var notifier=ToastNotificationManager.createToastNotifier();//(4)
        notifier.show(new ToastNotification(toastXml));
    }

    //タイトル+テキストのトースト表示
    function showToast3(title,text) {
        var toastXml=ToastNotificationManager.getTemplateContent(   //(1)
            ToastTemplateType.toastText02);                         //(2)
        var textNodes=toastXml.getElementsByTagName("text");        //(3)
        textNodes[0].appendChild(toastXml.createTextNode(title));
        textNodes[1].appendChild(toastXml.createTextNode(text));
        var notifier=ToastNotificationManager.createToastNotifier();//(4)
        notifier.show(new ToastNotification(toastXml));
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();
