﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var ApplicationView=Windows.UI.ViewManagement.ApplicationView;
    var ApplicationViewState=Windows.UI.ViewManagement.ApplicationViewState;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            } else {
                Application.onreactivated(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //リサイズイベントのイベントリスナーの追加(2)
        window.addEventListener("resize",Application.onresize);
        updateView();
    }

    //アプリ再開時に呼ばれる
    Application.onreactivated=function(args) {
        updateView();
    }

    //リサイズ時に呼ばれる
    Application.onresize=function() {
        updateView();
    }

    //アプリ開始
    Application.start();

    //ビュー更新時に呼ばれる
    function updateView() {
        //ビューステートの取得(3)
        if (ApplicationView.value==ApplicationViewState.snapped) {
            Debug.writeln("snapped");
        } else if (ApplicationView.value==ApplicationViewState.filled) {
            Debug.writeln("filled");
        } else if (ApplicationView.value==ApplicationViewState.fullScreenLandscape) {
            Debug.writeln("fullScreenLandscape");
        } else if (ApplicationView.value==ApplicationViewState.fullScreenPortrait) {
            Debug.writeln("fullScreenPortrait");
        }
    }
})();