﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var CreationCollisionOption=Windows.Storage.CreationCollisionOption;
    var FileIO=Windows.Storage.FileIO;
    var documentsLibrary=Windows.Storage.KnownFolders.documentsLibrary;
    WinJS.strictProcessing();

    //変数
    var myFile=null;

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //ファイルのオープン(1)
        documentsLibrary.createFileAsync("test.dat",
            CreationCollisionOption.openIfExists).then(
            function (file) {
                myFile=file;
            },
            function (error) {
                showDialog("ファイルオープン失敗");
            }
        );

        //イベントリスナーの指定
        $("writeButton").addEventListener("click",writeButton_onClick);
        $("readButton").addEventListener("click",readButton_onClick);
    };

    //アプリ開始
    Application.start();

    //書き込みボタンクリック時に呼ばれる
    function writeButton_onClick() {
        if (myFile==null) return;

        //ファイルの書き込み(2)
        var text=$("textarea").innerText;
        FileIO.writeTextAsync(myFile,text).then(
            function(data) {
            },
            function(error) {
                showDialog("ファイル書き込み失敗");
            }
        );
    }

    //読み込みボタンクリック時に呼ばれる
    function readButton_onClick() {
        if (myFile==null) return;

        //ファイルの読み込み(3)
        FileIO.readTextAsync(myFile).then(
            function(data) {
                $("textarea").innerText=data;
            },
            function(error) {
                showDialog("ファイル読み込み失敗");
            }
        );
    }

    //ダイアログの表示
    function showDialog(text) {
        var md=new MessageDialog(text);
        var cmd=new UICommand();
        cmd.label="OK";
        md.commands.append(cmd);
        md.showAsync();
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();