﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //イベントリスナーの指定
        $("readButton").addEventListener("click",readButton_onClick);
    }

    //アプリ開始
    Application.start();

    //読み込みボタン押下時に呼ばれる
    function readButton_onClick() {
        //HTTP通信(1)
        var connection=WinJS.xhr({url: "http://npaka.net/metro/test.txt"});
        connection.then(
            function(data){
                $("textarea").innerText=data.responseText;
            },
            function(error){
                $("textarea").innerText="通信エラー";
            }
        );
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();