﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //イベントリスナーの指定
        $("writeButton").addEventListener("click",writeButton_onClick);
        $("readButton").addEventListener("click",readButton_onClick);
    };

    //アプリ開始
    Application.start();

    //書き込みボタン押下時に呼ばれる
    function writeButton_onClick() {
        //ローカルストレージの書き込み(1)
        var text=$("textarea").innerText;
        Application.local.writeText("test",text);
    }

    //読み込みボタン押下時に呼ばれる
    function readButton_onClick() {
        //ローカルストレージの読み込み(2)
        Application.local.exists("test").done(
            function(exists) {
                if (!exists) return;
                Application.local.readText("test").done(
                    function(data) {
                       $("textarea").innerText=data;
                    }
                );
            }
        );
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();