import java.io.IOException;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

//`bg[
public class ChatRoom {
    private int idcounter=0;
    private Map<ChatWebSocket,Integer> users=
        new ConcurrentHashMap<ChatWebSocket,Integer>();

    //[U[
    public void join(ChatWebSocket ws) {
        if (users.containsKey(ws)) return;
        idcounter++;
        users.put(ws,idcounter);
        sendAll(idcounter+":join");
    }

    //[U[ގ
    public void leave(ChatWebSocket ws) {
        sendAll(users.get(ws)+":leave");
        users.remove(ws);
    }

    //bZ[WMɌĂ΂
    public void onMessage(ChatWebSocket ws,String msg) {
        sendAll(users.get(ws)+":"+msg);
    }

    //SɃbZ[WM
    public void sendAll(String msg) {
        System.out.println(msg);
        for (ChatWebSocket socket:users.keySet()) {
            try {
                socket.send(msg);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }
}