﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var CameraCaptureUI=Windows.Media.Capture.CameraCaptureUI;
    var CameraCaptureUIMode=Windows.Media.Capture.CameraCaptureUIMode;
    var FileAccessMode=Windows.Storage.FileAccessMode;
    var FileOpenPicker=Windows.Storage.Pickers.FileOpenPicker;
    var FileSavePicker=Windows.Storage.Pickers.FileSavePicker;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //イベントリスナーの指定
        $("button0").addEventListener("click",button0_onClick);
        $("button1").addEventListener("click",button1_onClick);
    };

    //アプリ開始
    Application.start();

    //カメラボタン押下時に呼ばれる
    function button0_onClick() {
        //カメラによる画像取得(1)
        var dialog=new CameraCaptureUI();
        dialog.photoSettings.croppedAspectRatio={width: 1,height: 1};
        dialog.captureFileAsync(CameraCaptureUIMode.photo).done(
            function (file) {
                if (file) {
                    //ストレージファイルのURL変換(2)
                    $("picture").src=URL.createObjectURL(file);
                }
            }
        );
    }

    //ファイルオープンピッカーボタン押下時に呼ばれる
    function button1_onClick() {
        var picker=new FileOpenPicker();
        picker.fileTypeFilter.replaceAll([".jpg",".bmp",".gif",".png"]);

        Debug.writeln("fileTypeFilter>>>>"+picker.fileTypeFilter);

        picker.pickSingleFileAsync().then(function (file) {
            if (file) {
                $("picture").src=URL.createObjectURL(file);
            }
        });
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})()