﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var FileAccessMode=Windows.Storage.FileAccessMode;
    var MessageDialog=Windows.UI.Popups.MessageDialog;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }

        //ファイルアクティベーションのコントラクト受信(1)
        else if (args.detail.kind==ActivationKind.file) {
            var file=args.detail.files[0];
            $("picture").src=URL.createObjectURL(file);
            $("output").innerText="ファイルアクティベーション";
        }

        //プロトコルアクティベーションのコントラクト受信(2)
        else if (args.detail.kind==ActivationKind.protocol) {
            //URLの取得
            $("output").innerText="プロトコルアクティベーション>"+
                args.detail.uri.absoluteUri;
        }

        //共有コントラクトのコントラクト受信(3)
        else if (args.detail.kind==ActivationKind.shareTarget) {
            args.detail.shareOperation.data.getTextAsync().done(
                function(text) {
                    $("output").innerText="共有コントラクト>"+text;
                }
            );
        }

        //検索コントラクトのコントラクト受信(4)
        else if (args.detail.kind==ActivationKind.search) {
            $("output").innerText="検索コントラクト>"+
                args.detail.queryText;

        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
    };

    //アプリ開始
    Application.start();

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();