﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var DataTransferManager=Windows.ApplicationModel.DataTransfer.DataTransferManager;
    var FileAccessMode=Windows.Storage.FileAccessMode;
    var RandomAccessStreamReference=Windows.Storage.Streams.RandomAccessStreamReference;
    var Launcher=Windows.System.Launcher;
    var MessageDialog=Windows.UI.Popups.MessageDialog;
    var Package=Windows.ApplicationModel.Package;
    var Uri=Windows.Foundation.Uri;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //共有コントラクトのイベントリスナーの指定(3)
        DataTransferManager.getForCurrentView().addEventListener(
            "datarequested",onDataRequested);

        //ボタンのイベントリスナーの指定
        $("button0").addEventListener("click",button0_onClick);
        $("button1").addEventListener("click",button1_onClick);
        $("button2").addEventListener("click",button2_onClick);
    };

    //アプリ開始
    Application.start();

    //ファイルアクティベーション押下時に呼ばれる
    function button0_onClick() {
        //ファイルアクティベーションのコントラクト送信(1)
        var imageFile="images\\sample.png";
        Package.current.installedLocation.getFileAsync(imageFile).then(
            function (file) {
                Launcher.launchFileAsync(file).then(
                    function(success) {
                        if (!success) showDialog("起動失敗");
                    }
                );
            }
        );
    }

    //プロトコルアクティベーション(http://npaka.net/)押下時に呼ばれる
    function button1_onClick() {
        //プロトコルアクティベーションのコントラクト送信(2)
        var uri=new Uri("http://npaka.net/");
        Launcher.launchUriAsync(uri).then(
            function(success) {
                if (!success) showDialog("起動失敗");
            }
        );
    }

    //プロトコルアクティベーション(myapp://npaka.net/)押下時に呼ばれる
    function button2_onClick() {
        //プロトコルアクティベーションのコントラクト送信(2)
        var uri=new Uri("myapp://npaka.net/");
        Launcher.launchUriAsync(uri).then(
            function(success) {
                if (!success) showDialog("起動失敗");
            }
        );
    }

    //共有コントラクト時に呼ばれる
    function onDataRequested(e) {
        //共有コントラクトの送信データの指定(3)
        e.request.data.properties.title="ContractSendEx";
        e.request.data.properties.description="テキストを共有";
        e.request.data.setText("これは共有テキストです");
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();