﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var BadgeNotification=Windows.UI.Notifications.BadgeNotification;
    var BadgeUpdateManager=Windows.UI.Notifications.BadgeUpdateManager;
    var BadgeTemplateType=Windows.UI.Notifications.BadgeTemplateType;
    var TileNotification=Windows.UI.Notifications.TileNotification;
    var TileTemplateType=Windows.UI.Notifications.TileTemplateType;
    var TileUpdateManager=Windows.UI.Notifications.TileUpdateManager;
    var XmlDocument=Windows.Data.Xml.Dom.XmlDocument;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //イベントリスナーの指定
        $("button0").addEventListener("click",button0_onClick);
        $("button1").addEventListener("click",button1_onClick);
        $("button2").addEventListener("click",button2_onClick);
    };

    //アプリ開始
    Application.start();

    //タイル更新ボタン押下時に呼ばれる
    function button0_onClick() {
        var tileXml=TileUpdateManager.getTemplateContent(
            TileTemplateType.tileWideImageAndText01);
        var textNodes=tileXml.getElementsByTagName("text")[0];
        textNodes.appendChild(tileXml.createTextNode("更新情報です"));
        var imageNodes=tileXml.getElementsByTagName("image")[0];
        imageNodes.setAttribute("src","/images/widelogo.png");
        TileUpdateManager.createTileUpdaterForApplication().
            update(new TileNotification(tileXml));
    }


    //ライブタイル更新ボタン押下時に呼ばれる
    function button1_onClick() {
        //ノティフィケーションキューの有効化
        TileUpdateManager.createTileUpdaterForApplication().
            enableNotificationQueue(true);

        //タイルの更新を10回行う
        for (var i=0;i<10;i++) {
            var tileXml=TileUpdateManager.getTemplateContent(
                TileTemplateType.tileWideImageAndText01);
            var textNodes=tileXml.getElementsByTagName("text")[0];
            textNodes.appendChild(tileXml.createTextNode("更新情報です："+i));
            var imageNodes=tileXml.getElementsByTagName("image")[0];
            imageNodes.setAttribute("src","/images/widelogo.png");
            TileUpdateManager.createTileUpdaterForApplication().
                update(new TileNotification(tileXml));
        }
    }

    //バッジ更新押下時に呼ばれる
    function button2_onClick() {
        var badgeUpdate=BadgeUpdateManager.createBadgeUpdaterForApplication();
        var template=BadgeUpdateManager.getTemplateContent(BadgeTemplateType.badgeNumber);
        var textNode=template.selectSingleNode("/badge");
        textNode.attributes[0].nodeValue="99";
        var badge=new BadgeNotification(template);
        badgeUpdate.update(badge);
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();