﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var Animation=WinJS.UI.Animation;
    WinJS.strictProcessing();

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        $("image1").style.opacity="0";

        //イベントリスナーの指定
        $("button0").addEventListener("click",button0_onClick);
        $("button1").addEventListener("click",button1_onClick);
        $("button2").addEventListener("click",button2_onClick);
        $("button3").addEventListener("click",button3_onClick);
        $("button4").addEventListener("click",button4_onClick);
        $("button5").addEventListener("click",button5_onClick);
        $("button6").addEventListener("click",button6_onClick);
    };

    //アプリ開始
    Application.start();

    //EnterPageボタン押下時に呼ばれる
    function button0_onClick() {
        //EnterPageアニメーション(1)
        Animation.enterPage($("content"),null);
    }

    //ExitPageボタン押下時に呼ばれる
    function button1_onClick() {
        //ExitPageアニメーション(1)
        Animation.exitPage($("content"),null).then(function(){
            //3秒後にページを戻す
            setTimeout(function(){
                Animation.enterPage($("content"),null);
            },3000);
        });
    }

    //EnterContentボタン押下時に呼ばれる
    function button2_onClick() {
        //EnterContentアニメーション(2)
        Animation.enterContent($("image0"),null);
    }

    //ExitContentボタン押下時に呼ばれる
    function button3_onClick() {
        //ExitContentアニメーション(2)
        Animation.exitPage($("image0"),null);
    }

    //FadeInボタン押下時に呼ばれる
    function button4_onClick() {
        //FadeInアニメーション(3)
        Animation.fadeIn($("image0"));
    }

    //FadeOutボタン押下時に呼ばれる
    function button5_onClick() {
        //FadeOutアニメーション(3)
        Animation.fadeOut($("image0"));
    }

    //CrossFadeボタン押下時に呼ばれる
    function button6_onClick() {
        //CrossFadeアニメーション(4)
        if ($("image0").style.opacity==="0") {
            Animation.crossFade($("image0"),$("image1"));
        } else {
            Animation.crossFade($("image1"),$("image0"));
        }
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();