﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var MediaControl=Windows.Media.MediaControl;
    WinJS.strictProcessing();

    //変数
    var audio;

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //オーディオの取得
        audio=$("audio");

        //メディアコントロールのイベントリスナーの追加(3)
        MediaControl.addEventListener("playpausetogglepressed",playpause);
        MediaControl.addEventListener("playpressed",play);
        MediaControl.addEventListener("stoppressed",stop);
        MediaControl.addEventListener("pausepressed",pause);

        //ボタンのイベントリスナーの指定
        $("playButton").addEventListener("click",playButton_onClick);
        $("pauseButton").addEventListener("click",pausepButton_onClick);
    };

    //アプリ開始
    Application.start();

    //PlayPauseToggleコマンド受信時に呼ばれる(3)
    function playpause() {
        if (!audio.paused) {
            audio.pause();
        } else {
            audio.play();
        }
    }

    //Playコマンド受信時に呼ばれる(3)
    function play() {
        audio.play();
    }

    //Stopコマンド受信時に呼ばれる(3)
    function stop() {
        audio.pause();
    }

    //Pauseコマンド受信時に呼ばれる(3)
    function pause() {
        audio.pause();
    }

    //再生ボタン押下時に呼ばれる
    function playButton_onClick() {
        //サウンドの再生(2)
        audio.currentTime=0;
        audio.play();
    }

    //停止ボタン押下時に呼ばれる
    function pausepButton_onClick() {
        //サウンドの一時停止(2)
        audio.pause();
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();