﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    WinJS.strictProcessing();

    //変数
    var video;

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //ビデオの取得
        video=$("video");

        //イベントリスナーの指定
        $("playButton").addEventListener("click",playButton_onClick);
        $("pauseButton").addEventListener("click",pauseButton_onClick);
    };

    //アプリ開始
    Application.start();

    //再生ボタン押下時に呼ばれる
    function playButton_onClick() {
        //動画の再生(2)
        video.currentTime=0;
        video.play();
    }

    //停止ボタン押下に呼ばれる
    function pauseButton_onClick() {
        //動画の一時停止(2)
        video.pause();
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();