﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    WinJS.strictProcessing();

    //シーン定数(1)
    var S_TITLE   =0;
    var S_PLAY    =1;
    var S_CLEAR   =2;
    var S_GAMEOVER=3;
    
    //システム
    var canvas;
    var context;
    var updateTime=0;

    //ゲーム
    var scene;             //シーン(1)
    var init=S_TITLE;      //次のシーン(1)
    var images=new Array();//イメージ
    var score=0;           //スコア
    var touchX=-1;         //タッチX座標
    
    //ブロック(2)
    var block=new Array();//ブロック状態

    //ボール(3)
    var ballX =0;//ボールX座標
    var ballY =0;//ボールY座標
    var ballVX=0;//ボールX速度
    var ballVY=0;//ボールY速度
    
    //バー(3)
    var barX=0;   //バーX座標    
    var barY=1030;//バーY座標
    
    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //コンテキストの取得
        canvas=$("canvas");
        context=canvas.getContext("2d");

        //コンテキストの初期化
        context.font="42px 'Meiryo UI'";
        context.strokeStyle="rgb(255,255,255)";
        context.fillStyle  ="rgb(255,255,255)";

        //ブロックの初期化(2)
        for (var i=0;i<12;i++) block.push(new Array());

        //イメージの読み込み
        for (var i=0;i<16;i++) {
            var image=new Image();
            image.src="/images/pic"+i+".png";
            images.push(image);
        }

        //イベントリスナーの追加
        canvas.addEventListener("MSPointerDown",onMSPointerDown);
        canvas.addEventListener("MSPointerMove",onMSPointerMove);

        //イメージ読み込み待ち
        preload(images,animate);
    }

    //アプリ開始
    Application.start();

    //イメージ読み込み待ち
    function preload(images,onComplete) {
        var loadImages=function() {
            var count=0;
            for(var i=0;i<16;i++) {
                if(images[i].complete) count++;
            }
            if (count<images.length) {
                setTimeout(loadImages,100);
            } else {
                onComplete();
            }
        };
        loadImages();
    }


    //アニメーションフレームのループ処理
    function animate() {
        var currentTime=new Date().getTime();
        if (updateTime<=currentTime) {
            updateTime=currentTime+50-currentTime%50;
            onTick();
        }
        window.msRequestAnimationFrame(animate);
    }

    //定期処理
    function onTick() {
        //シーンの初期化
        if (init>=0) {
            //タイトルの初期化(2)
            if (init==S_TITLE) {
                for (var i=0;i<8;i++) {
                    block[0][i]=5;block[1][i]=5;
                    block[2][i]=4;
                    block[3][i]=3;block[4][i]=3;
                    block[5][i]=2;block[6][i]=2;
                    block[7][i]=1;block[8][i]=1;
                    block[9][i]=0;block[10][i]=0;block[11][i]=0;
                }
                ballX =360;
                ballY =barY-30;
                ballVX=0;
                ballVY=0;
                barX  =360;
            } 
            //プレイの初期化
            else if (init==S_PLAY) {
                score=0;
                ballVX= 4;
                ballVY=-4;
            } 
            scene=init;
            init=-1;
        }

        //プレイ時の処理
        if (scene==S_PLAY) {
            for (var i=0;i<8;i++) moveBall();
            barX=touchX;
        }
        
        //背景とボタンの描画
        if (scene==S_TITLE) {
            context.drawImage(images[8],0,0);
            context.drawImage(images[9],220,1000);
        } else if (scene==S_PLAY) {
            context.drawImage(images[10],0,0);
        } else if (scene==S_CLEAR) {
            context.drawImage(images[13],0,0);
            context.drawImage(images[15],220,1000);
        } else if (scene==S_GAMEOVER) {
            context.drawImage(images[14],0,0);
            context.drawImage(images[15],220,1000);
        }
        
        if (scene==S_PLAY) {
            //ブロックの描画
            for (var j=0;j<block.length;j++) {
                for (var i=0;i<block[j].length;i++) {
                    if (block[j][i]<0) continue;
                    context.drawImage(images[block[j][i]],90*i,130+32*j);
                }
            }
            
            //バーとボールの描画
            context.drawImage(images[7],barX-120,barY-20);
            context.drawImage(images[6],ballX-36,ballY-36);
        }
        
        //スコアの描画
        drawScore(score);
    }

    //スコアの描画
    function drawScore(score) {
        if (score>999999) score=999999;
        context.drawImage(images[11],310,20);
        var value=1000000;
        for (var i=0;i<6;i++) {
            value=Math.floor(value/10);
            var num=Math.floor(score/value);
            context.drawImage(images[12],num*40,0,40,50,470+40*i,20,40,50);
            score-=num*value;
        }
    }

    //ボール移動
    function moveBall() {
        if (init>=0) return;

        //ボールの移動(4)
        ballX+=ballVX;
        ballY+=ballVY;
                
        //周囲との衝突判定(5)
        if (ballX<0)   {ballX=0;  ballVX=-ballVX;}
        if (720<ballX) {ballX=720;ballVX=-ballVX;}
        if (ballY<0)   {ballY=0;  ballVY=-ballVY;}
        if (ballY>1280+36) init=S_GAMEOVER;
                
        //ブロックとの衝突判定(6)
        var blockNum=0;        
        for (var j=0;j<12;j++) {
            for (var i=0;i<8;i++) {
                if (block[j][i]<0) continue;
                blockNum++;
                var r=hitRect(
                    ballX-ballVX,ballY-ballVY,ballX,ballY,
                    i*90,130+j*32,90,32);
                if (r>=0) {
                    if (r==0 || r==1) ballVY=-ballVY;
                    if (r==2 || r==3) ballVX=-ballVX;
                    block[j][i]=-1;
                    score+=10;
                    break;
                }
            }
        }
        if (scene==S_PLAY && blockNum==0) init=S_CLEAR;
                
        //バーとの衝突判定(7)
        var r=hitRect(
            ballX-ballVX,ballY-ballVY,ballX,ballY,
            barX-120,barY-10,240,barY+10);
        if (r>=0) {
            if (r==0) ballVY=-4-rand(2);
            if (r==1) ballVY=-ballVY;
            if (r==2 || r==3) ballVX=-ballVX;
        }        
    }

    //直線と矩形の衝突判定(6)
    function hitRect(x0,y0,x1,y1,x2,y2,w2,h2) {
        if (x2<=x1 && x1<=x2+w2 && y2<=y1 && y1<=y2+h2) {
            if (hitLine(x0,y0,x1,y1,x2,   y2,   x2+w2,y2   )) return 0;//上
            if (hitLine(x0,y0,x1,y1,x2,   y2+h2,x2+w2,y2+h2)) return 1;//下
            if (hitLine(x0,y0,x1,y1,x2,   y2,   x2,   y2+h2)) return 2;//左
            if (hitLine(x0,y0,x1,y1,x2+w2,y2   ,x2+w2,y2+h2)) return 3;//右
        }
        return -1;
    }
    
    //2つの直線の衝突判定(8)
    function hitLine(x0,y0,x1,y1,x2,y2,x3,y3) {
        var r=((y3-y2)*(x2-x0)-(x3-x2)*(y2-y0))/((x1-x0)*(y3-y2)-(y1-y0)*(x3-x2));
        var s=((y1-y0)*(x2-x0)-(x1-x0)*(y2-y0))/((x1-x0)*(y3-y2)-(y1-y0)*(x3-x2));
        return (0<r && r<=1 && 0<s && s<=1);
    }
    
    //乱数の取得
    function rand(num) {
        return parseInt(Math.random()*num);        
    }

    //ポインタダウンイベントの処理
    function onMSPointerDown(event) {
        if (scene==S_TITLE) init=S_PLAY;
        if (scene==S_CLEAR || scene==S_GAMEOVER) init=S_TITLE;
        touchX=event.offsetX;
    }

    //ポインタムーブイベントの処理
    function onMSPointerMove(event) {
        touchX=event.offsetX;
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();