﻿(function () {
    "use strict";
    var Application=WinJS.Application;
    var Activation=Windows.ApplicationModel.Activation;
    var ActivationKind=Activation.ActivationKind;
    var ApplicationExecutionState=Activation.ApplicationExecutionState;
    var MessageDialog=Windows.UI.Popups.MessageDialog;
    var Binding=WinJS.Binding;
    var Namespace=WinJS.Namespace;
    var UICommand=Windows.UI.Popups.UICommand;
    WinJS.strictProcessing();

    //検索ワード(1)
    var searchWord="#windows8";

    //データ
    var data;

    //アプリ起動時と再開時に呼ばれる
    Application.onactivated=function(args) {
        if (args.detail.kind===ActivationKind.launch) {
            if (args.detail.previousExecutionState!==
                ApplicationExecutionState.terminated) {
                Application.onlaunched(args);
            }
            args.setPromise(WinJS.UI.processAll());
        }
    };

    //アプリ起動時に呼ばれる
    Application.onlaunched=function(args) {
        //タイトルの指定
        $("title").innerText=searchWord;

        //イベントリスナーの指定
        $("updateButton").addEventListener("click",function(){
            updateTimeline(1);
            $("appBar").winControl.hide();
        });

        //タイムラインの更新
        updateTimeline(1);
    }

    //アプリ開始
    Application.start();

    //タイムラインの更新
    function updateTimeline(page) {
        //タイムライン更新の初期化
        if (page===1) {
            $("progress").style.visibility="visible";
            data=new Array();
        }
        //検索結果の取得(2)
        var connection=WinJS.xhr({
            url: "http://search.twitter.com/search.json?lang=ja&q="+
                encodeURIComponent(searchWord)+"&page="+page,
            headers: {"Pragma": "no-cache"}//(3)        
        });
        connection.then(
            function(result){
                var jsonData=JSON.parse(result.responseText);
                for (var i=0;i<jsonData.results.length;i++) {
                    data.push({
                        picture: jsonData.results[i].profile_image_url, 
                        title: jsonData.results[i].from_user_name,
                        text: jsonData.results[i].text});
                }
                if (page<5) {
                    updateTimeline(page+1);
                } else {
                    var dataList=new Binding.List(data);
                    $("listView").winControl.itemDataSource=dataList.dataSource;
                    $("progress").style.visibility="hidden";
                }
            },
            function(error){
                showDialog("通信エラー");
            }
        );
    }

    //ダイアログの表示
    function showDialog(text) {
        var md=new MessageDialog(text);
        var cmd=new UICommand();
        cmd.label='OK';
        md.commands.append(cmd);
        md.showAsync();
    }

    //要素の取得
    function $(id) {
        return document.getElementById(id);
    }
})();